<template>
  <div id="entitySelector">
    <EntityList
      :entityList="items"
      :selectedEntityName="selectedEntityName"
      v-on:selectedEntity="(name) => $emit('selectedEntity', name)"
    />
    <EntityList
      :entityList="monsters"
      :selectedEntityName="selectedEntityName"
      v-on:selectedEntity="(name) => $emit('selectedEntity', name)"
    />
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue, Prop } from "vue-property-decorator";
import { Entity, knownEntities } from "../../../../services/editor/entities";
import EntityList from "./EntityList.vue";

@Component({
  components: {
    EntityList: EntityList
  }
})
export default class EntitySelector extends Vue {
  private entities: Entity[] = [];

  @Prop() selectedEntityName!: string;

  created(): void {
    this.entities = Object.values(knownEntities);
  }

  get items(): Entity[] {
    return this.entities.filter((entity) => entity.type === "item");
  }

  get monsters(): Entity[] {
    return this.entities.filter((entity) => entity.type === "monster");
  }
}
</script>

<style scoped>
#entitySelector {
  height: 100%;
  display: flex;
}
</style>
